/****************************************************************************/
/* Prctica n 3	Criba de Eratstenes                                */
/*                                                                          */
/* Fecha: 5 Noviembre 1996                                                  */
/*                                                                          */
/* Autor: Oscar Martnez Valpuesta                                          */
/*                                                                          */
/* Finalidad: Se pretende implementar el algoritmo de la criba de Eratstenes*/
/*	      para calcular los nmeros primos de un conjunto dado de N     */
/*	      nmeros.                                                      */
/*		El algoritmo se basa en lo siguiente:                       */
/*	      1. Generar un conjunto que contenga todos los nmeros entre  */
/*                el 2 y N.                                                 */
/*	      2. Seleccionar el menor n del conjunto al que llamaremos    */
/*		  primo_actual.                                             */
/*	      3. Mientras el cuadrado de primo_actual  N hacer:           */
/*		    - Eliminar del conjunto los elementos de la forma       */
/*		      primo_actual * k para k > 1                           */
/*		    - Reemplazar el primo_actual por el menor elemento del  */
/*		      conjunto mayor que l.                                */
/*                                                                          */
/* Comentarios: Los conjuntos de elementos van a ser palabras de bits en las*/
/*		que si un nmero pertenece a ese conjunto su bit estar a 1 */
/*		y si no a 0. Las palabras parten desde el 0.Ejemplo: el 2   */
/*	        pertenece => 100, el 3 pertenece. 			    */
/*		=> 1000, el 2 y 3 pertenecen => 1100.                       */
/****************************************************************************/

#include <stdio.h>		/* printf, scanf */
#include <conio.h>		/* getch */
#include "cnjlib.c"


unsigned n;			/* n de entrada */
set criba;
int j;

/* prototipos */
void Introducir(void);
void Eliminar(unsigned e);
void Eratostenes(void);

/**************************************************************************/
void Introducir(void) {
register unsigned i;

  printf("\nIntroduce el nmero de elementos: ");
  scanf("%d", &n);
  criba = *cnjini(n);
  for (i = 2; i <= n; i++)
    cnjins(&criba, i);
}

/**************************************************************************/
void Eliminar(unsigned e) {
unsigned i;
palabra j;

  if (cnjper(&criba, e) != 0) {
    i = PAL(e);
    j = (1UL << BIT(e));
    criba.conj[i] ^= j;
  }
}

/**************************************************************************/
void Eratostenes(void) {
unsigned primo_actual, anterior;
unsigned i, k;
int pertenece;

  primo_actual = 2;
  anterior = 2;
  while ((primo_actual * primo_actual) <= n) {
    for (k = 2; (primo_actual * k) <= n; k++)
      Eliminar(primo_actual * k);
    i = anterior;
    pertenece = 0;
    while (pertenece == 0) {
      i++;
      pertenece = cnjper(&criba, i);
    }
    primo_actual = i;
    anterior = i;
  }
}

/**************************************************************************/
int main(void) {

  Introducir();
  Eratostenes();
  printf("\nEl conjunto de nmeros primos es: ");
  for (j = 0; j < criba.longitud; j++)
    printf("\n%ld", criba.conj[j]);
  getch();
  return 0;
}

