/* Rutinas de manejo de una cola */

#include <stdio.h> 		/* printf, scanf */
#include <stdlib.h>		/* calloc, exit */
#include "cnjlib.c"
#include "a:\util.c"

/* set **cola; */

unsigned frente, atras, limite;

/* prototipos */
boolean Cola_vacia(void);
void initCola(set ***v, unsigned N);
void inserta_cola(set ***v, set *e);
void saca_cola(set ***v, set *e);
void Libera_cola(set ***v, unsigned k);

/***************************************************************************/
boolean Cola_vacia(void) {

  if (frente == atras)
    return TRUE;
  else
    return FALSE;
}


/***************************************************************************/
/* Funcin que reserva en primer lugar memoria para la estructura de la cola
 y si esto ha sido posible reserva memoria para los N elementos que contendr
 como mximo.                                                               */
/***************************************************************************/
void initCola(set ***v, unsigned N) {
register i;

  *v = (set **) malloc (N * sizeof(set));	/* memoria para la estructura */
  if (*v == NULL) {
    printf("\nERROR, no se ha podido dar memoria a la cola.");
    exit(1);
  }
   for (i= 0; i < N; i++)
    *v[i] = cnjini(N);
  /* inicialmente el puntero al frente coincide con el de atrs */
  frente = 0;
  atras = 0;
  limite = N;
}

/****************************************************************************/
/* Funcin que inserta en la cola un elemento e incrementando el puntero a  */
/* atrs.                                                                   */
/****************************************************************************/
void inserta_cola(set ***v, set *e) {

  if (atras == limite) {	/* toda la pila ocupada */
    printf("\nNo queda ms espacio en la cola.");
    exit(1);
  }
  *v[atras] = e;
  /* cnjcpy(e, v[atras]);*/
  atras++;
}

/***************************************************************************/
/* Funcin que extrae de la colaa un elemento e si esta tiene al menos uno. */
/***************************************************************************/
void saca_cola(set ***v, set *e) {

  if (frente == atras) {
    printf("\nERROR, la cola est vaca.");
    exit(1);
  }
  /* e = v[frente]; */
   cnjcpy(*v[frente], e);
  frente++;
}

/***************************************************************************/
/* Funcin que libera de la memoria toda la cola, la estructura y lo que se
 haba reservado para los N elementos.                                     */
/***************************************************************************/
void Libera_cola(set ***v, unsigned k) {
register i;
  for (i = 0; i < k; i++)
    cnjlib(*v[i]);
  free(*v);
}

/***************************************************************************/
/* int main(void) {
unsigned num;
register unsigned i;
set *conj;

  clrscr();
  initCola(cola, 10);
  do {
    printf("Introduce el n de elementos del conjunto: ");
    scanf("%d", &num);
    if (num != 0) {
      conj = cnjini(num);
	for (i = 0; i < num; i++)
	  cnjins(conj, i);
      inserta_cola(cola, conj);
    }
  } while (num != 0);

  clrscr();

  while (!Cola_vacia()) {
    conj = cnjini(10);
    saca_cola(cola, &conj);
    printf("Conjunto: ");
    for (i = 0; i < 10; i++)
      if (cnjper(conj, i))
	printf("%d, ", i);
    printf("\nIdentificador: %d\n", frente);
    Pausa();
  }
  Libera_cola(cola);
  return 0;
} */
