/* Rutinas de manejo de una cola */

#include <stdio.h> 		/* printf, scanf */
#include <stdlib.h>		/* calloc, exit */
#include "cnjlib.c"
#include "a:\util.c"

typedef struct tipo_nodo{
  set *conjunto;
  unsigned identificador;
  struct tipo_nodo *sig;
}nodo;

typedef struct tipo_cola {
  nodo *frente,
       *atras;
}COLA;

nodo *n;
set *conj;
COLA *c = NULL;
/* prototipos */
boolean Cola_vacia(COLA *cola);
void initCola(COLA *cola);
void push(COLA *cola, nodo *e);
void pop(COLA *cola, nodo **e);
void Libera_cola(COLA *cola);

/**************************************************************************/
boolean Cola_vacia(COLA *cola) {
  if (cola -> frente == NULL)
    return TRUE;
  else
    return FALSE;
}

/**************************************************************************/
void initCola(COLA *cola) {

  cola -> frente = NULL;
  cola -> atras = NULL;
}

/**************************************************************************/
void push(COLA *cola, nodo *e) {
nodo *q;

  q = (nodo *) malloc(sizeof(nodo));
  if (q == NULL) {
    printf("\nERROR, no se ha podido dar memoria al nodo.");
    exit(0);
  }
  *q = *e;
  q -> sig = NULL;
  if (cola -> frente ==NULL)
    cola -> frente = q;
  else
    cola -> atras -> sig = q;
  cola -> atras = q;
}

/**************************************************************************/
void pop(COLA *cola, nodo **e) {
nodo *q;

  if (Cola_vacia(cola)) {
    printf("\nERROR, cola vaca.");
    exit(0);
  }
  *e = cola -> frente;
  q = cola -> frente;
  cola -> frente = cola -> frente -> sig;
  free(q);
}

/**************************************************************************/
void Libera_cola(COLA *cola) {
nodo *q;

  while (!Cola_vacia(cola)) {
    q = cola -> frente;
    cola -> frente = cola -> frente -> sig;
    free(q);
  }
}

/**************************************************************************/
int main(void) {
unsigned k, num;
register unsigned i;

  clrscr();
  initCola(c);
  n = (nodo *)malloc(sizeof(nodo));
  do {
    clrscr();
    printf("Identificador: ");
    scanf("%d", &n -> identificador);
    if (n -> identificador != 0) {

      printf("Introduce el n de elementos del conjunto: ");
      scanf("%d", &num);
      conj = cnjini(num);
      for (i = 0; i < num; i++){
	clrscr();
	printf("Nmero: ");
	scanf("%d", &k);
	cnjins(conj, k);
      }
      n -> conjunto = conj;
      n -> sig = NULL;
      push(c, n);
    }

  } while (n -> identificador != 0);

  clrscr();
  while (!Cola_vacia(c)) {
    pop(c, &n);
    printf("Conjunto: ");
    for (i = 0; i < 10; i++)
      if (cnjper(n -> conjunto, i))
	printf("%d, ", i);
    printf("\nIdentificador: %d\n", n -> identificador);
    Pausa();
  }

  return 0;
}