/***************************************************************************/
/* Prctica n 1	Algoritmo de Goldbath                              */
/*                                                                         */
/* Fecha: 22 Octubre 1996                                                  */
/*                                                                         */
/* Autor: Oscar Martnez Valpuesta                                         */
/*                                                                         */
/* Comentarios: Goldbath afirma que cualquier nmero par puede ser         */
/*		expresado como la suma de dos primos.                      */
/*		  Para llegar a la solucin cogemos el primer nmero primo */
/*		menor que el que queremos hallar. Calculamos la diferencia */
/*		entre ambos y si este ltimo no es primo se coge el        */
/*		inmediatamente inferior al primero y se vuelve a hacer la  */
/*		resta. Por ejemplo, para 21 el primer primo menor que l   */
/*		es el 19. El otro nmero es el 21 - 19 = 3.     	   */
/*	        (1352 = 1327 + 25 ==> 1352 = 1321 + 31)                    */
/*									   */
/*  Uso: 	El programa aplica el algoritmo de Goldbath a todos los    */
/*		nmeros pares entre los introducidos (que no tienen por qu*/
/*  		ser pares) como parmetros en la lnea de comandos. Los    */
/*		resultados se almacenan en el fichero de texto 'salida.txt'*/
/*		del directorio actual.       				   */
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef enum {FALSE, TRUE} boolean;

int inicial;
int final;
int i;
FILE *fichero;			  /*fichero de salida*/

/* prototipos de las funciones a usar */
void GD(int x);
void Comprobar(char *a[]);
boolean Es_primo(int x);

/***************************************************************************/
/* Esta funcin calcula el valor x como suma de dos nmeros primos         */
/***************************************************************************/
void GD(int x){
int j;
int a;			   /* primer n primo */
int b;                     /* segundo n primo */
boolean salir;

  j = x;
  salir = FALSE;
  while (salir == FALSE) {
    while(Es_primo(j) != TRUE)
      j--;
    a = j;				/* primer n primo por debajo de x */
    b = x - a;
    if (Es_primo(b) == TRUE)            /* si el segundo es primo */
      salir = TRUE;                     /* salimos */
    j--;
  }
 fprintf(fichero, "%d= %d + %d\n", x, a, b);
}

/***************************************************************************/
/* Funcin que comprueba que los parmetros pasados al programa estn entre*/
/* los predeterminados							   */
/***************************************************************************/
void Comprobar(char *a[]){
  inicial = atoi(a[1]);
  if ((inicial < 3)){
    printf("ERROR, el primer nmero debe ser mayor que 2. \n");
    exit(0);
  }
  final = atoi(a[2]);
  if ((final < inicial)) {
    printf("ERROR, el ltimo nmero debe ser mayor o igual que el primero. \n");
    exit(0);
  }
}

/***************************************************************************/
/* Funcin que devuelve si un nmero es priomo o no                        */
/***************************************************************************/
boolean Es_primo(int x){
int j;

  j= 2;
  while (j < x) {
    if ((x % j) == 0)
      return(FALSE);
    j++;
  }
  return(TRUE);
}

/***************************************************************************/
main(int argc, char *argv[]) {


  if (argc != 3){
    printf("ERROR, introduce dos nmeros como parmetros.\n");
    exit(0);
  }
  Comprobar(argv);
  fichero = fopen("salida.txt", "w+");
  if (fichero == NULL){
    printf("ERROR, el fichero no ha podido abrirse.\n");
    exit(0);
  }
  for (i = inicial; i <= final; i++)
    if ((i % 2) == 0)		/* solo los nmeros pares */
      GD(i);
  fclose(fichero);
  printf("La solucin se encuentra en el fichero de texto 'salida.txt'.\n");
  return(0);
}

