/****************************************************************************/
/* Prctica n 6	Conversor de NFA a DFA                              */
/*                                                                          */
/* Fecha: 26 Noviembre 1996                                                 */
/*                                                                          */
/* Autor: Oscar Martnez Valpuesta                                          */
/*                                                                          */
/* Comentarios: ESTA PRACTICA NO FUNCIONA !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/****************************************************************************/

#include "pila.c"		/* incluye stdio, stdlib, conio */
#include "cola.c"		/* incluye cnjlib, util */
#include <string.h>		/* strlen */
#include <sys\stat.h>           /* S_IWRITE, S_IREAD */
#include <io.h>			/* creat */

#define MAXSTR 20 		/* tamao de las frases de entrada */
#define MAX 10			/* tamao del alfabeto y de la matriz */

typedef struct {
  char entrada;			/* entrada con que se transita */
  unsigned nuevo_estado;	/* nuevo estado al que se pasa */
} transicion;

typedef struct {
  unsigned num_transis;          /* n de transiciones del estado */
  transicion *tran;		 /* lista de transiciones */
} estados;

FILE *fich;			/* handler para los ficheros */
estados **nfa;			/* estructura del NFA */
unsigned num_estados;		/* n de estados del NFA */
unsigned e_inicial;		/* estado de arranque del NFA */
unsigned e_aceptacion;		/* estado de aceptacin */
char alfabeto[MAX];		/* alfabeto reconocido por el NFA */
int matriz_delta[MAX][MAX];

/* prototipos */
void Iniciar(void);
void Abrir(char s[]);
boolean Contenido(char a);
void Leer_NFA(void);
void Clausura(PILA *p, set *conjunto);
void move(set *conjunto, char a);
int Find(set **c, set *conjunto);
void Conversion(char s[]);
void Visualizar(char s[], set **c);

/***************************************************************************/
void Iniciar(void) {
register unsigned i, j;

  for (i = 0; i < MAX; i++)
    for (j = 0; j < MAX; j++)
      matriz_delta[i][j] = -2;
}

/***************************************************************************/
/* Funcin que abre un fichero de alto nivel para lectura.                 */
/***************************************************************************/
void Abrir(char s[]) {

  fich = fopen(s, "r");
  if (fich == NULL) {
    printf("\nERROR, el fichero %s no se ha podido abrir.", s);
    exit(0);
  }
}

/***************************************************************************/
boolean Contenido(char a) {
unsigned length;
register unsigned i;

  length = strlen(alfabeto);
  if (a == '')
    return TRUE;
  else
    if (length == 0)
      return FALSE;
    else
      for (i = 0; i < length; i++)
	if (alfabeto[i] == a)
	  return TRUE;
  return FALSE;
}

/***************************************************************************/
/* Fucin encargada de crear la estructura de datos del NFA.               */
/***************************************************************************/
void Leer_NFA(void) {
register unsigned i, j;
unsigned k;				/* estado actual */
char iguales;

  strcpy(alfabeto,"");

  fscanf(fich, "%d", &num_estados);	/* lectura del n total de estados */
  fscanf(fich, "%d", &e_inicial);	/* lectura del estado inicial */
  fscanf(fich, "%d", &e_aceptacion);	/* lectura del estado de aceptacin */

  /* memoria para la estructura */
  nfa = (estados **) malloc(num_estados * sizeof(estados));
  if (nfa == NULL) {
    printf("\nERROR, no se ha podido dar memoria a la estructura.");
    exit(0);
  }
  for (j = 0; j < num_estados; j++) {
    fscanf(fich, "%d", &k);			/* lectura estado actual */

    /* memoria para el estado actual */
    nfa[k] = (estados *) malloc(sizeof(estados));
    if (nfa[k] == NULL) {
      printf("\nERROR, no se ha podido dar memoria al registro.");
      exit(0);
    }

    fscanf(fich, "%d", &nfa[k] -> num_transis);	/* lectura del n de transiciones */
    /* memoria para los registros de transiciones, si hay transiciones */
    if (nfa[k] -> num_transis != 0) {
      nfa[k] -> tran = (transicion *) calloc(nfa[k] -> num_transis, sizeof(transicion));
      if (nfa[k] -> tran == NULL) {
	printf("\nERROR, no se ha podido dar memoria a las transiciones.");
	exit(0);
      }

      /* lectura de las transiciones del estado actual */
      for (i = 0; i < nfa[k] -> num_transis; i++) {
	fscanf(fich, " %c", &nfa[k] -> tran[i].entrada);
	if (!Contenido(nfa[k] -> tran[i].entrada)) {
	  alfabeto[strlen(alfabeto)] = nfa[k] -> tran[i].entrada;
	  alfabeto[strlen(alfabeto)] = '\0';
	}
	fscanf(fich, "%d", &nfa[k] -> tran[i].nuevo_estado);
      }
    }
  }
}

/***************************************************************************/
/* Funcin que realiza la -clausura de un conjunto de estados y devuelve  */
/* en el mismo conjunto su clausura. El conjunto final est formado por    */
/* todos los estados alcanzables con 0 o ms -transiciones. Hace uso de   */
/* una pila en la que va insertando todos los estados alcanzables por una  */
/* -transicin.
/***************************************************************************/
void Clausura(PILA *p, set *conjunto) {
register unsigned i;
unsigned t;			/* estado a tratar */

  /* introduccin en la pila de todos los estados a clausurar */
  for (i = 0; i < num_estados; i++)
    if (cnjper(conjunto, i))
      push(p, i);

  while (!PILA_VACIA(p -> s)) {
    pop(p, &t);		/* extraccin de un elemento */
    for (i = 0; i < nfa[t] -> num_transis; i++)  /* para cada transicin */
      if (nfa[t] -> tran[i].entrada == '')	 /* cuya entrada sea  */
	/* si no est en la clausura el estado al que se transita, */
	/* se introduce en la clausura y en pila para ser tratado despus */
	if (!cnjper(conjunto, nfa[t] -> tran[i].nuevo_estado)) {
	  cnjins(conjunto, nfa[t] -> tran[i].nuevo_estado);
	  push(p, nfa[t] -> tran[i].nuevo_estado);
	}
  }
}

/***************************************************************************/
/* Funcin que calcula las transiciones de un conjunto de estados mediante */
/* la entrada a. Vamos a ayudarnos de un conjunto auxiliar que contendr   */
/* los nuevos estados a los que se transita.                               */
/***************************************************************************/
void move(set *conjunto, char a) {
register unsigned i, j;
boolean acepta;                 /* TRUE si el estado actaul acepta la entrada */
set *aux;			/* conjunto auxiliar */

  aux = cnjini(num_estados);		/* memoria para el conjunto auxiliar */

/* para cada estado que pertenece al conjunto inicial se calcula su transicin */
  for (i = 0; i < num_estados; i++)
    if (cnjper(conjunto, i)) {
      acepta = FALSE;
      /* ver si el estdo actual acepta la entrada */
      for (j = 0; j < nfa[i] -> num_transis && !acepta; j++)
	if (nfa[i] -> tran[j].entrada == a)
	  acepta = TRUE;
      j--;

      if (acepta) 		/* caracter de entrada vlido */
	cnjins(aux, nfa[i] -> tran[j].nuevo_estado);
    }

  /* se vacia el conjunto inicial y se copia en l el conj. de estados a */
  /* los que se ha transitado (conjunto auxiliar) */
  cnjvac(conjunto);
  cnjcpy(aux, conjunto);
  cnjlib(aux);
}

/***************************************************************************/
int Find(set **c, set *conjunto) {
register i;
int iguales = -2;
boolean vacio = TRUE;

  for (i = 0; i < num_estados && vacio; i++)
    if (cnjper(conjunto, i))
      vacio = FALSE;
  if (vacio)
    return 0;
  else {
    for (i = 0; i < atras; i++)
      if (cnjigu(c[i], conjunto))
	iguales = i;
    if (iguales == -2)
      return -1;
    return iguales;
  }
}

/***************************************************************************/
void Conversion(char s[]) {
unsigned i;
PILA *p;
set **cola;
set *conj;
set *aux;
unsigned length;
int Uid;
unsigned count = 0;
unsigned estado = 1;

  length = strlen(alfabeto);

  p = initPila(num_estados);
  initCola(&cola, 10);

  conj = cnjini(num_estados);


  cnjins(conj, e_inicial);
  Clausura(p, conj);
  inserta_cola(&cola, conj);
  Iniciar();

  while(!Cola_vacia()) {
    conj = cnjini(num_estados);
    saca_cola(&cola, conj);
    for (i = 0; i < length; i++) {
      aux = cnjini(num_estados);
      cnjcpy(conj, aux);
      move(aux, alfabeto[i]);
      Clausura(p, aux);
      Uid = Find(cola, aux);
      if (Uid == -1) {
	inserta_cola(&cola, aux);
	matriz_delta[count][i] = estado++;
      }
      else
	matriz_delta[count][i] = Uid;
    }
  count++;
  }
  Libera_pila(p);
  Visualizar(s, cola);
  Libera_cola(&cola, num_estados);
}

/***************************************************************************/
void Visualizar(char s[], set **c) {
register unsigned i, j;
unsigned length;
unsigned num_transis = 0;

/*  fclose(fich);
  fich = fopen(s, "w+");
  if (fich == NULL) {
    printf("\nERROR, el fichero de destino no se ha podido crear.");
    exit(1);
  }
  fprintf(fich, "%d\n", atras);		/* nmero de estados */
/*  fprintf(fich, "%d\n", 0);             /* estado de arranque */
  clrscr();
  printf("El 0 indica que no transita para esa entrada\n\n");
  length = strlen(alfabeto);
  for (j = 0; j < length; j++)
    printf(" %c ", alfabeto[j]);
  for (i = 0; i < atras; i++) {
    printf("\n");
  /*  fprintf(fich, "%d ", i);
    if (cnjper(cola[i], e_aceptacion))
      fprintf(fich, "%d ", 1);
    else
      fprintf(fich, "%d ", 0);
    for (j = 0; j < length; j++)
      if (matriz_delta[i][j] != -2)
	num_transis++;
    fprintf(fich, "%d ", num_transis); */
    for (j = 0; j < length; j++)
/*      if (matriz_delta[i][j] != -2) {
	fprintf(fich, "%c ", alfabeto[j]);
	fprintf(fich, "%d ", matriz_delta[i][j]);
      } */
      printf("%d ", matriz_delta[i][j]);
  }
  Pausa();
  fclose(fich);
}

/***************************************************************************/
int main(int argc, char *argv[]) {

  if (argc != 3){
    printf("\nERROR, forma de uso: archivo_de_definicin.NFA archivo_de_salida.DFA\n");
    exit(0);
  }
  Abrir(argv[1]);	      /* apertura fichero de definicin */
  Leer_NFA();		      /* caractersticas del autmata */
  Conversion(argv[2]);
  return 0;
}