/****************************************************************************/
/* Prctica n 7     Minimizacin del nmero de estados de un DFA           */
/*                                                                          */
/* Fecha: 3 Diciembre 1996                                                  */
/*                                                                          */
/* Autor: Oscar Martnez Valpuesta                                          */
/*                                                                          */
/* Comentarios: ESTA PRACTICA NO FUNCIONA !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/****************************************************************************/
#include <stdio.h>		/* printf, fscanf, fopen, feof */
#include <conio.h>		/* getch */
#include <stdlib.h>		/* exit, calloc */
#include <string.h>
#include <util.c>
#include <cnjlib.c>

#define MAXSTR 20 		/* tamao de las frases de entrada */
#define MAX 20

typedef struct {
  char entrada;			/* entrada con que se transita */
  unsigned nuevo_estado;	/* nuevo estado al que se pasa */
} transicion;

typedef struct {
  unsigned num_transis;
  transicion *tran;
  boolean aceptacion;
} estados;


FILE *fich;
estados **dfa;			/* estructura del DFA */
unsigned num_estados;		/* n de estados del DFA */
unsigned e_inicial;		/* estado inicial del DFA */
char alfabeto[MAXSTR];          /* alfabeto reconocido por el DFA */
estados **dfa2;			/* dfa minimizado */

/* prototipos */
boolean Contenido(char a);
void Abrir(FILE **f, char s[]);
void Visualizar(void);
void Leer_DFA(void);
void Iniciar(set *X[]);
void Vaciar(set *X[]);
boolean Iguales(set *A[], set*B[]);
void Vaciar(set *X[MAX]);
void Igualar(set *A[], set*B[]);
void Union(set *A[], set *B[]);
unsigned N_elem(set *G);
void part(set *T[], set *G, char a, set *lista[]);
void descomp(set *T[], set *G, set *lista[]);
void crear_nueva_particion(set *lista[MAX], set *lista_v[MAX]);
void Minimizacion(void);

/***************************************************************************/
boolean Contenido(char a) {
unsigned length;
register unsigned i;

  length = strlen(alfabeto);
  if (length == 0)
    return FALSE;
  else
    for (i = 0; i < length; i++)
      if (alfabeto[i] == a)
	return TRUE;
  return FALSE;
}

/***************************************************************************/
/* Funcin que abre un fichero de alto nivel para lectura.                 */
/***************************************************************************/
void Abrir(FILE **f, char s[]) {

  *f = fopen(s, "r");
  if (*f == NULL) {
    ERROR1(s);
    exit(0);
  }
}

/***************************************************************************/
/* Procedimiento que muestra en pantalla las caractersticas del autmata. */
/***************************************************************************/
void Visualizar(void) {
register unsigned i, j;

  printf("\nEstado Aceptacin Transiciones");
  for (i = 0; i < num_estados; i++) {
    printf("\n [%d]       %d       %d ", i, dfa[i] -> aceptacion, dfa[i] -> num_transis);
    for (j = 0; j < dfa[i] -> num_transis; j++)
      printf("%c %d ", dfa[i] -> tran[j].entrada, dfa[i] -> tran[j].nuevo_estado);
  }
  printf("\n\nAlfabeto reconocido: %s", alfabeto);
  Pausa();
}
/***************************************************************************/
/* Fucin encargada de crear la estructura de datos del DFA.               */
/***************************************************************************/
void Leer_DFA(void) {
register unsigned i, j;
unsigned k;			       /* estado actual */

  strcpy(alfabeto,"");

  fscanf(fich, "%d", &num_estados);	/* lectura del n total de estados */
  fscanf(fich, "%d", &e_inicial);	/* lectura del estado inicial */

  /* memoria para la estructura */
  dfa = (estados **) malloc(num_estados * sizeof(estados));
  if (dfa == NULL) {
    printf("\nERROR, no se ha podido dar memoria a la estructura.");
    exit(0);
  }
  for (j = 0; j < num_estados; j++) {
    fscanf(fich, "%d", &k);		/* lectura estado actual */

    /* memoria para el estado actual */
     dfa[k] = (estados *) malloc(sizeof(estados));
     if (dfa[k] == NULL) {
       printf("\nERROR, no se ha podido dar memoria al registro.");
       exit(0);
     }
     fscanf(fich, "%d", &dfa[k] -> aceptacion);
     fscanf(fich, "%d", &dfa[k] -> num_transis);

     /* memoria para los registros de transiciones */
     if (dfa[k] -> num_transis > 0) {
       dfa[k] -> tran = (transicion *) calloc(dfa[k] -> num_transis, sizeof(transicion));
       if (dfa[k] -> tran == NULL) {
	 printf("\nERROR, no se ha podido dar memoria a las transiciones.");
	 exit(0);
       }

       /* lectura de las transiciones del estado actual */
       for (i = 0; i < dfa[k] -> num_transis; i++) {
	 fscanf(fich, " %c", &dfa[k] -> tran[i].entrada);
	 fscanf(fich, "%d", &dfa[k] -> tran[i].nuevo_estado);
	 if (!Contenido(dfa[k] -> tran[i].entrada)) {
	   alfabeto[strlen(alfabeto)] = dfa[k] -> tran[i].entrada;
	   alfabeto[strlen(alfabeto)] = '\0';
	 }
       }
     }  /* if num_transis > 0 */
  } /* for todos los estados */
}

/***************************************************************************/
void Iniciar(set *X[]) {
register unsigned i;

  for (i = 0; i < MAX; i++)
    X[i] = cnjini(num_estados);
}

/***************************************************************************/
void Liberar(set *X[]) {
register unsigned i;
unsigned item;

  item = X[0]->longitud;
  for (i = 0; i < item; i++)
    cnjlib(X[i]);
}

/***************************************************************************/
boolean Iguales(set *A[], set *B[]) {
register unsigned i;

  if (A[0]->longitud != B[0]->longitud)
    return FALSE;
  else
    for (i = 1; i < A[0]->longitud; i++)
      if (!cnjigu(A[i], B[i]))
	return FALSE;
  return TRUE;
}

/***************************************************************************/
void Vaciar(set *X[MAX]) {
register unsigned i;
unsigned items;

  items = X[0]->longitud;
  for (i = 1; i < items; i++)
    cnjvac(X[i]);
  X[0]->longitud = 1;
}

/***************************************************************************/
void Igualar(set *A[], set *B[]) {
register unsigned i;

  B[0]->longitud = A[0]->longitud;
  for (i = 1; i < B[0]->longitud; i++)
    cnjcpy(A[i], B[i]);
}

/***************************************************************************/
void Union(set *A[], set *B[]){
register unsigned i, j, k;
boolean encontrado;
unsigned n_elem;
unsigned num = 1;

  n_elem = A[0]->longitud;
  if (n_elem > 1) {
    for (i = 1; i < A[0]->longitud; i++) {
      encontrado = FALSE;
      for(j = 1; j < B[0]->longitud && !encontrado; j++)
	if(cnjigu(A[i], B[j]))
	  encontrado = TRUE;
      if (!encontrado)
	for (k = 1; k < B[0]->longitud; k++)
	  for (j = 1; j < A[0]->longitud && !encontrado; j++)
	    if(cnjigu(A[j], B[k]))
	      encontrado = TRUE;
      if (!encontrado) {
	cnjcpy(B[num++], A[n_elem++]);
	A[0]->longitud = n_elem;
      }
    }
  }

  else
    for (i = 1; i < B[0]->longitud; i++)
      cnjcpy(B[i], A[i]);
  if (B[0]->longitud > A[0]->longitud)
    A[0]->longitud = B[0]->longitud;
}

/***************************************************************************/
unsigned N_elem(set *G) {
register unsigned i;
unsigned N = 0;

  for (i = 0; i < num_estados; i++)
    if (cnjper(G, i))
      N++;
  return N;
}

/***************************************************************************/
void part(set *T[], set *G, char a, set *lista[]) {
register unsigned i, j, k;
set *aux[MAX];

  Iniciar(aux);
  Vaciar(T);
  for (i = 1; i < lista[0]->longitud && N_elem(lista[i]) > 2; i++) {
    for(j = 0; j < num_estados; j++)
      if (cnjper(G, j))
	for (k = 0; k < dfa[j]->num_transis; k++)
	  if ((dfa[j]->tran[k].entrada == a) && (cnjper(lista[i],dfa[j]->tran[k].nuevo_estado))) {
	   /* Vaciar(aux);
	    cnjins(aux[1],j);
	    aux[0]->longitud = 2;
	    Union(T, aux);*/
	    cnjins(T[1], j);
	    T[0]->longitud = 2;
	  }
  }
  Liberar(aux);
}

/***************************************************************************/
void descomp(set *T[], set *G, set *lista[]) {
unsigned pos = 1;
unsigned length;
register unsigned i, j;
set *T_[MAX];
set *P[MAX];

  length = strlen(alfabeto);
  cnjcpy(G, T[pos++]);
  T[0]->longitud = pos;
  Iniciar(T_);
  Iniciar(P);
  for (i = 0; i < length; i++) {
    Vaciar(P);
    for (j = 1; j < T[0]->longitud; j++) {
      Vaciar(T_);
      if (N_elem(T[j]) > 1)
	part(T_, T[j], alfabeto[i], lista);
      Union(P, T_);
    }
    Vaciar(T);
    Igualar(P, T);
  }
  Liberar(T_);
  Liberar(P);
}

/***************************************************************************/
void crear_nueva_particion(set *lista[MAX], set *lista_v[MAX]) {
register unsigned i;
set *T[MAX];

  Iniciar(T);
  Vaciar(lista);
  for (i = 1; i < lista_v[0]->longitud; i++) {
    Vaciar(T);
    descomp(T, lista_v[i], lista_v);
    Union(lista, T);
  }
  Liberar(T);
}

/***************************************************************************/
void Minimizacion(void) {
register unsigned i;
set *lista[MAX];
set *lista_v[MAX];

  Iniciar(lista);
  Iniciar(lista_v);
  lista[0] -> longitud = 3;

  for (i = 0; i < num_estados; i++)
    if (dfa[i] -> aceptacion)
      cnjins(lista[2], i);
    else
      cnjins(lista[1], i);

  do {
    Igualar(lista, lista_v);
    crear_nueva_particion(lista, lista_v);
  } while (!Iguales(lista, lista_v));
  Pausa();
  Liberar(lista);
  Liberar(lista_v);
}

/***************************************************************************/
int main(int argc, char *argv[]) {

  clrscr();
  if (argc != 3){
	 printf("\nERROR, forma de uso: <autmata.DFA> <minimo.DFA\n");
	 printf("\nautmata.DFA: fichero de definicin del autmata.");
	 printf("\nmnimo.DFA: fichero con el autmata minimizado.");
	 exit(0);
  }
  Abrir(&fich, argv[1]);	      /* apertura fichero de definicin */
  Leer_DFA();			      /* caractersticas del autmata */
  Visualizar();
  Minimizacion();
  return 0;
}
