/***************************************************************************/
/* Prctica n 2	ORDENACION DE FICHEROS                             */
/*                                                                         */
/* Fecha: 29 Octubre 1996                                                  */
/*                                                                         */
/* Autor: Oscar Martnez Valpuesta                                         */
/*                                                                         */
/* Uso:   Este programa comprueba si el fichero introducido est ordenado  */
/*	o no. Para ello se basa en comparar un elemento con el siguiente   */
/*      hasta llegar al final del fichero. Si antes de leer todos los items*/
/*	descubre dos que no estn ordenados finaliza las comparaciones y   */
/*	acaba.                                                             */
/***************************************************************************/

#include <stdio.h>
#include <io.h>		/* open */
#include <fcntl.h>	/* O_BINARY, O_RDWR */
#include <stdlib.h>	/* exit, malloc, calloc */

typedef struct {
  unsigned clave;
  char c;
  int i;
  float r;
  char cadena[50];
  int v[100];
} registro;

typedef enum {FALSE = 0, TRUE = 1} boolean;

char s[100];                    /* trayectoria y nombre del fichero */
int fichero;
registro *buffer, *buffer2;	/* comparacin de registros */
boolean ordenado = TRUE;	/* indica si el fichero est ordenado */

/**************************************************************************/
int main() {

  printf("\nIntroduce el fichero a comprobar: ");
  gets(s);

  /* apertura fichero */
  _fmode = O_BINARY;
  fichero = open(s, O_BINARY | O_RDWR);
  if (fichero == -1) {
    printf("\nERROR, fichero no abierto correctamente.");
    exit(1);
  }

  /* dar memoria */
  buffer = (registro *) malloc(sizeof(registro));
  buffer2 = (registro *) malloc(sizeof(registro));
  if (buffer == NULL || buffer2 == NULL) {
    printf("ERROR, no se ha podido dar memoria al buffer.\n");
    exit(1);
  }

  /* comparaciones entre elementos */
  while (ordenado && !eof(fichero)) {
    read(fichero, buffer, sizeof(registro));
    read(fichero, buffer2, sizeof(registro));
    if (buffer -> clave > buffer2 -> clave)
      ordenado = FALSE;
  }

  if (ordenado)
    printf("\nFichero %s ordenado correctamente.", s);
  else
    printf("\nFichero %s no ordenado correctamente.", s);

  close(fichero);
  return 0;
}
